#!/bin/bash

set -e

cd "$(dirname "$0")"

cd images
[ ! -e mac.img ] && qemu-img create -f qcow2 -b mac-full-forplayers.img mac.img
cd ..

image=images/mac.img

if [ ! -e OSX-KVM ]; then
  git clone https://github.com/kholia/OSX-KVM
fi

MY_OPTIONS="+pcid,+ssse3,+sse4.2,+popcnt,+avx,+aes,+xsave,+xsaveopt,check"
qemu_opts=(
  -accel kvm
  -cpu Penryn,vendor=GenuineIntel,vmware-cpuid-freq=on,"$MY_OPTIONS,+invtsc"
  -machine pc-q35-2.11
  -smp 4,cores=4
  -m 4096
  -usb -device usb-kbd -device usb-tablet
  -device isa-applesmc,osk="ourhardworkbythesewordsguardedpleasedontsteal(c)AppleComputerInc"
  -drive if=pflash,format=raw,readonly,file=./OSX-KVM/OVMF_CODE.fd
  -drive if=pflash,format=raw,readonly,file=./OSX-KVM/OVMF_VARS-1024x768.fd
  -smbios type=2
  -device ide-drive,bus=ide.2,drive=Clover
  -drive id=Clover,if=none,snapshot=on,format=qcow2,file=./Clover-sip.qcow2
  -device ide-drive,bus=ide.1,drive=MacHDD
  -drive id=MacHDD,if=none,file="$image",format=qcow2
  -device e1000-82545em,netdev=net0,id=net0,mac=52:54:00:c9:18:27
  -netdev user,id=net0,hostfwd=tcp:127.0.0.1:10022-:22
  -monitor stdio
  )
qemu-system-x86_64 "${qemu_opts[@]}"
